/////////////////////////////////////////////////////////////////////////////
// Name:        XYPadControl.cpp
// Purpose:     
// Author:      jrg piringer
// Modified by: 
// Created:     04/05/2006 23:28:28
// RCS-ID:      
// Copyright:   
// Licence:     LGPL
/////////////////////////////////////////////////////////////////////////////

#include <wx/wx.h>
#include <wx/dcbuffer.h>
#include "XYPadControl.h"

IMPLEMENT_DYNAMIC_CLASS(XYPadControl, wxControl)


DEFINE_EVENT_TYPE(wxEVT_XYPAD)


BEGIN_EVENT_TABLE(XYPadControl, wxControl)
	EVT_PAINT(XYPadControl::OnPaint)
	EVT_ERASE_BACKGROUND(XYPadControl::OnEraseBackground)
	EVT_LEFT_DOWN(XYPadControl::OnLeftDown)
	EVT_MOTION(XYPadControl::OnMotion) 
END_EVENT_TABLE()

// code implementing the event type and the event class

XYPadEvent::XYPadEvent(wxEventType commandType, int id)
: wxNotifyEvent(commandType,id)
{
}

///////////////////////////////////////////////////////

XYPadControl::XYPadControl(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size)
: wxWindow(parent,id,pos,size)
{
}

void XYPadControl::OnPaint(wxPaintEvent& event)
{
	wxBufferedPaintDC dc(this);
	wxColour drawColour = wxColour(0,0,0);

	PrepareDC(dc);

	PaintBackground(dc);

	dc.SetBrush(wxBrush(drawColour));
	dc.SetPen(wxPen(drawColour, 1));
	dc.DrawCircle(x,y,3);
}

void XYPadControl::PaintBackground(wxDC& dc)
{
	wxColour backgroundColour = wxColour(255,255,255); //GetBackGroundColour();
	/*if(!backgroundColour.OK())
		backgroundColour = wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE);*/

	dc.SetBrush(wxBrush(backgroundColour));
	dc.SetPen(wxPen(backgroundColour, 1));

	wxRect windowRect(wxPoint(0,0),GetClientSize());

	//CalcUnscrolledPosition(windowRect.x, windowRect.y, &windowRect.x, &windowRect.y);

	dc.DrawRectangle(windowRect);
}

void XYPadControl::OnEraseBackground(wxEraseEvent& event)
{
}

void XYPadControl::OnLeftDown(wxMouseEvent& event)
{
	x = event.GetX();
	y = event.GetY();

	xf = (float)x / (float)GetClientSize().GetWidth();
	yf = (float)y / (float)GetClientSize().GetHeight();

    XYPadEvent nevent(wxEVT_XYPAD, GetId());
    nevent.SetEventObject(this);
    nevent.SetValues(xf,yf);
    GetEventHandler()->ProcessEvent(nevent);

	Refresh();

	event.Skip();
}

void XYPadControl::OnMotion(wxMouseEvent& event)
{
	if(event.LeftIsDown())
	{
		OnLeftDown(event);
	}
	event.Skip();
}
