/////////////////////////////////////////////////////////////////////////////
// Name:        XYPadControl.cpp
// Purpose:     
// Author:      jrg piringer
// Modified by: 
// Created:     04/05/2006 23:28:28
// RCS-ID:      
// Copyright:   
// Licence:     LGPL
/////////////////////////////////////////////////////////////////////////////

#ifndef _XYPADCONTROL_

#define _XYPADCONTROL_

#include <wx/event.h>

class XYPadEvent: public wxNotifyEvent
{
public:
    XYPadEvent(wxEventType commandType = wxEVT_NULL, int id = 0);

    // accessors
	float GetX() { return x; }
	float GetY() { return y; }

	void SetValues(float _x, float _y) {x = _x; y = _y;}

    // required for sending with wxPostEvent()
    wxEvent* Clone();

private:
    float x;
	float y;
};

BEGIN_DECLARE_EVENT_TYPES()
     DECLARE_EVENT_TYPE(wxEVT_XYPAD, -1)
END_DECLARE_EVENT_TYPES()

typedef void (wxEvtHandler::*XYPadEventFunction)(XYPadEvent&);

#define EVT_XYPAD(id, fn) \
    DECLARE_EVENT_TABLE_ENTRY( wxEVT_XYPAD, id, -1, \
    (wxObjectEventFunction) (wxEventFunction) (wxCommandEventFunction) (wxNotifyEventFunction) \
    wxStaticCastEvent( XYPadEventFunction, & fn ), (wxObject *) NULL ),



class XYPadControl : public wxWindow
{
    DECLARE_DYNAMIC_CLASS(XYPadControl)
    DECLARE_EVENT_TABLE()

	int x, y;
	float xf, yf;
public:
	XYPadControl() {}
	XYPadControl(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize);

	void OnPaint(wxPaintEvent& event);
	void PaintBackground(wxDC& dc);
	void OnEraseBackground(wxEraseEvent& event);

	void OnLeftDown(wxMouseEvent& event);
	void OnMotion(wxMouseEvent& event);
};


#endif
