/////////////////////////////////////////////////////////////////////////////
// Name:        capture.h
// Purpose:     
// Author:      jrg piringer
// Modified by: 
// Created:     19/05/2006 23:22:42
// RCS-ID:      
// Copyright:   
// Licence:     LGPL
/////////////////////////////////////////////////////////////////////////////

#ifndef __CAPTURE_H__
#define __CAPTURE_H__

#include <wx/process.h>
#include <wx/txtstrm.h>

#include "OSCWindow.h"

// This is the handler for process termination events
class OSCWindow;
class OSCProcess : public wxProcess
{
	long m_id;
public:
    OSCProcess(OSCWindow *parent, const wxString& cmd)
        : wxProcess((wxEvtHandler *)parent), m_cmd(cmd)
    {
        m_parent = parent;
        m_id = 0;
    }

    // instead of overriding this virtual function we might as well process the
    // event from it in the frame class - this might be more convenient in some
    // cases
    virtual void OnTerminate(int pid, int status);
    
    void SetId(long id) {m_id = id;}
    long GetId() {return m_id;}

protected:
    OSCWindow *m_parent;
    wxString m_cmd;
};

// A specialization of MyProcess for redirecting the output
class OSCPipedProcess : public OSCProcess
{
	wxNotebookPage *nbpage;
public:
    OSCPipedProcess(OSCWindow *parent, const wxString& cmd, wxNotebookPage *_nbpage)
        : OSCProcess(parent, cmd)
        {
			nbpage = _nbpage;
            Redirect();
        }

    virtual void OnTerminate(int pid, int status);

    virtual bool HasInput();
};

// Define an array of process pointers used by MyFrame
class OSCPipedProcess;
WX_DEFINE_ARRAY_PTR(OSCPipedProcess *, OSCProcessesArray);

#endif //__CAPTURE_H__
